import { MouseEvent } from 'react'

export function removeFromObjRecursive(nodeName: string, nextJsDataObject: any) {
  return JSON.parse(
    JSON.stringify(nextJsDataObject, function (key, value) {
      if (key !== nodeName) return value
    })
  )
}

export function replaceEmailsRecursive(name: string, nextJsDataObject: any) {
  return JSON.parse(
    JSON.stringify(nextJsDataObject, function (key, value) {
      if (key === name) return encodeEmail(value)
      return value
    })
  )
}

export function encodeEmail(emailAddress: string) {
  return btoa(emailAddress)
}

export function decodeEmail(encodedEmailAddress: string) {
  return atob(encodedEmailAddress)
}

export function handleMailtoEvent(mouseEvent: MouseEvent<HTMLAnchorElement>) {
  const targetElement = mouseEvent.currentTarget
  const base = targetElement.dataset.base
  const mail = decodeEmail(base)
  targetElement.href = 'mailto:' + mail
  return true
}

export default {
  removeFromObjRecursive,
  replaceEmailsRecursive,
  encodeEmail,
  decodeEmail,
  handleMailtoEvent
}
